	PAGE	,132
;	THIS PROGRAM IS A SHELL THAT RUNS A PROGRAM AND
;	RESERVES THE TOP 64K OF SYSTEM MEMORY SO THAT THE
;	CHILD PROGRAM WILL NOT USE IT
;
;	TO USE THIS PROGRAM, ENTER
;
;	RUNPROG <PROGRAM> [<ARGUMENTS>]
;
;	WHERE <PROGRAM> IS THE COMPLETE PATH NAME DESCRIBING 
;	THE PROGRAM YOU WANT TO RUN, AND <ARGUMENTS> ARE ANY
;	ARGUMENTS REQUIRED BY THE PROGRAM.
;
;	COPYRIGHT (C) HEATH/ZENITH USERS' GROUP 1988.  ALL RIGHTS RESERVED.
;
;	BY PATRICK SWAYNE, HUG SOFTWARE ENGINEER  28-JUN-88

CODE	SEGMENT
	ASSUME	CS:CODE,DS:CODE,ES:CODE,SS:CODE
	ORG	0
ZERO	LABEL	NEAR
	ORG	2CH
ENVSEG	LABEL	WORD			;ENVIRONMENT SEGMENT
	ORG	5CH
FCB1	LABEL	BYTE			;FIRST FCB
	ORG	6CH
FCB2	LABEL	BYTE			;SECOND FCB
	ORG	80H
ARG	LABEL	BYTE			;ARGUMENT AREA
	ORG	100H

;	SET UP FOR EXECUTION OF PROGRAM

START:	MOV	DX,OFFSET SIGNON
	CALL	PMSG			;PRINT SIGN-ON
	MOV	AH,30H
	INT	21H			;GET DOS VERSION
	CMP	AL,2			;TEST IT
	JNB	VERSOK			;VERSION OK
	MOV	DX,OFFSET BADVER
	CALL	PMSG			;SAY "BAD VERSION"
	INT	20H
VERSOK:	MOV	FCB1,0			;ZERO FCB1 DRIVE
	MOV	FCB2,0			;AND FCB2 DRIVE
	CLD
	MOV	DI,OFFSET FCB1+1
	MOV	AL,' '
	MOV	CX,11
	REP	STOSB			;CLEAR FCB1
	MOV	DI,OFFSET FCB2+1
	MOV	CX,11
	REP	STOSB			;CLEAR FCB2
	MOV	SI,OFFSET ARG		;POINT TO USER ARGUMENT
	MOV	DI,OFFSET ENDADR	;POINT TO FREE SPACE
	MOV	CX,80H/2
	REP	MOVSW			;COPY ARGUMENT THERE
	MOV	SI,OFFSET ENDADR	;NOW, POINT TO IT HERE
	LODSB				;GET COUNT
	OR	AL,AL			;ANY COUNT?
	JNZ	GOTINP			;YES, WE HAVE USER INPUT
NOINP:	MOV	DX,OFFSET NPMSG
	CALL	PMSG			;ELSE, SAY "NO PROGRAM"
	INT	20H

;	GET THE PROGRAM NAME

GOTINP:	XOR	AH,AH			;MAKE COUNT A WORD
	MOV	CX,AX			;COUNT TO CX
	CALL	SOS			;SKIP SPACES
	JZ	NOINP			;NO USER INPUT
	MOV	DI,OFFSET PRGNAM	;PUT PROGRAM NAME HERE
MOVPGM:	LODSB				;GET A CHARACTER
	CMP	AL,' '			;END OF PROGRAM NAME?
	JZ	GOTSW			;YES
	CMP	AL,13			;COULD END IN CR
	JZ	GOTEND
	CMP	AL,'/'			;COULD END IN SWITCH
	JZ	GOTSW
	STOSB				;STORE IT
	LOOP	MOVPGM			;ELSE, LOOP
	JMP	NOARG			;RAN OUT OF CHARACTERS, NO ARGUMENT
GOTSW:	DEC	SI			;BACK UP TO SWITCH
	INC	CX			;CANCEL NEXT DEC
GOTEND:	DEC	CX			;COUNT THE SEPARATOR
	MOV	BYTE PTR [DI],0		;NULL END OF PROGRAM NAME
	JZ	NOARG			;NO ARGUMENT SPECIFIED

;	SET UP THE COMMAND ARGUMENT AND THE FCB'S

	PUSH	CX			;SAVE COUNT
	PUSH	SI			;AND LOCATION
	MOV	ARG,CL			;SAVE ARGUMENT LENGTH
	MOV	DI,OFFSET ARG+1		;PUT PROGRAM ARGUMENT HERE
	REP	MOVSB			;MOVE ARGUMENT
	POP	SI			;RESTORE POINTER
	POP	CX			;AND COUNT
	CALL	SOS			;SKIP SPACES
	JZ	NOARG
	MOV	DI,OFFSET FCB1		;POINT TO FIRST FCB
	MOV	AX,2900H
	PUSH	SI			;SAVE POINTER
	INT	21H			;PARSE FIRST NAME
	POP	SI
FNDTRM:	MOV	AL,[SI]			;GET NEXT CHARACTER
	CMP	AL,' '			;SPACE?
	JZ	GOTTRM
	CMP	AL,','			;COMMA?
	JZ	GOTTRM
	CMP	AL,';'			;SEMI?
	JZ	GOTTRM
	CMP	AL,'='
	JZ	GOTTRM
	INC	SI
	LOOP	FNDTRM			;LOOK FOR TERMINATOR
	JMP	SHORT GOTARG		;NONE FOUND, NO 2ND ARG
GOTTRM:	INC	SI			;PASS OVER TERMINATOR
	DEC	CX			;COUNT IT
	JZ	NOARG			;THAT WAS THE END
	CALL	SOS			;SKIP ANY SPACES
	JZ	NOARG			;ONLY SPACES LEFT
	MOV	DI,OFFSET FCB2		;POINT TO SECOND FCB
	MOV	AX,2900H
	INT	21H			;PARSE SECOND NAME
	JMP	SHORT GOTARG
NOARG:	MOV	WORD PTR ARG,0D00H	;INSERT NULL COUNT, CR
GOTARG:	CLI
	MOV	SP,OFFSET ENDADR	;PUT STACK HERE
	STI

;	PROCESS PROGRAM NAME

	MOV	DX,OFFSET FNDBUF
	MOV	AH,1AH
	INT	21H			;SET DTA TO FIND BUFFER
	XOR	BP,BP			;CLEAR EXTENSION FLAG
	MOV	DI,OFFSET PRGNAM	;POINT TO PROGRAM NAME
	MOV	AL,'.'
	MOV	CX,80
	REPNZ	SCASB			;LOOK FOR "."
	JNZ	NOEXT			;NO EXTENSION SPECIFIED
	CMP	WORD PTR [DI],'OC'	;LOOK FOR "COM"
	JNZ	NOTCOM			;NOT "COM"
	CMP	BYTE PTR 2[DI],'M'
	JZ	LOOK2			;WE HAVE COM
NOINPJ:	JMP	NOINP			;EXPLAIN PROGRAM
NOTCOM:	CMP	WORD PTR [DI],'XE'	;LOOK FOR "EXE"
	JNZ	NOINPJ			;NOT "EXE"
	CMP	BYTE PTR 2[DI],'E'
	JZ	LOOK2			;EXTENSION SPECIFIED, LOOK FOR FILE
	JMP	NOINPJ
NOEXT:	INC	BP			;FLAG EXTENSION SUPPLIED
	MOV	DI,OFFSET PRGNAM
	XOR	AL,AL
	MOV	CX,80
	REPNZ	SCASB			;ELSE, LOOK FOR END
	DEC	DI			;POINT TO IT
	MOV	WORD PTR [DI],'C.'	;MOVE IN .COM
	MOV	WORD PTR 2[DI],'MO'
	MOV	DX,OFFSET PRGNAM
	MOV	CX,0
	MOV	AH,4EH
	INT	21H			;LOOK FOR PROGRAM
	JNC	GOTPRG			;GOT IT
	MOV	BYTE PTR 1[DI],'E'	;ELSE, MAKE PROGRAM .EXE
	MOV	WORD PTR 2[DI],'EX'
LOOK2:	MOV	CX,0
	MOV	AH,4EH
	MOV	DX,OFFSET PRGNAM
	INT	21H			;LOOK FOR PROGRAM
	JNC	GOTPRG			;GOT IT
	MOV	DX,OFFSET NOFIND
	CALL	PMSG			;ELSE, SAY "CAN'T FIND"
	OR	BP,BP			;EXTENSION SUPPLIED?
	JZ	NOEXS			;NO
	MOV	WORD PTR [DI],0A0DH	;ELSE, INSERT CR,LF
	MOV	BYTE PTR 2[DI],'$'
NOEXS:	MOV	DX,OFFSET PRGNAM
	CALL	PMSG			;PRINT FILE NAME
	INT	20H
GOTPRG:

;	PREPARE TO RUN THE PROGRAM

PRPRUN:	PUSH	CS
	POP	DS			;FIX DS
	MOV	BX,(ENDADR-ZERO+15) SHR 4	;POINT TO END PARA.
	MOV	AH,4AH
	INT	21H			;FREE UP MEMORY FOR PROGRAM TO RUN
	JC	CNTEX			;SOMETHING'S WRONG
	MOV	AX,5801H
	MOV	BX,2
	INT	21H			;SET ALLOCATION TO LAST FIT
	JC	CNTEX
	MOV	AH,48H
	MOV	BX,0FFFH
	INT	21H			;RESERVE 64K AT TOP
	JC	CNTEX
	MOV	AX,5801H
	XOR	BX,BX
	INT	21H			;RESTORE ALLOCATION TO NORMAL
	MOV	AX,ENVSEG
	MOV	PBENV,AX		;SET UP ENV. SEGMENT ADDRESS
	MOV	PBCMD+2,CS		;SET UP SEGMENT FOR CMD LINE
	MOV	PBFCB1+2,CS		;SET UP FCB1 SEGMENT
	MOV	PBFCB2+2,CS		;SET UP FCB2 SEGMENT

;	RUN THE PROGRAM

	MOV	DX,OFFSET PRGNAM	;POINT TO PROGRAM NAME
	MOV	BX,OFFSET PBLOCK	;AND TO PARAMETER BLOCK
	MOV	AX,4B00H		;PROGRAM EXEC FUNCTION
	INT	21H			;TRY TO EXECUTE PROGRAM
	JNC	EXECOK			;IT WAS OK
CNTEX:	MOV	DX,OFFSET NOEXEC
	CALL	PMSG			;SAY "CAN'T RUN"

;	ALL DONE, EXIT

EXECOK:	INT	20H

;	SUBROUTINES
;	SKIP OVER SPACES

SOS:	CMP	BYTE PTR [SI],' '	;SPACE?
	JNZ	NOTSP			;NO
	INC	SI			;ELSE, SKIP IT
	LOOP	SOS
NOTSP:	OR	CX,CX			;SET FLAG ON COUNT
	RET

;	PRINT MESSAGES, SKIPPING ZEROS

PMSG:	PUSH	SI
	MOV	SI,DX			;POINT TO MESSAGE
	CLD
PMSGLP:	LODSB				;GET A CHARACTER
	OR	AL,AL			;ZERO
	JZ	PMSGLP			;SKIP IT
	CMP	AL,'$'			;END?
	JZ	PMSGX
	MOV	DL,AL
	MOV	AH,2
	INT	21H			;PRINT CHARACTER
	JMP	PMSGLP
PMSGX:	POP	SI
	RET

;	DATA AREA

;	PARAMETER BLOCK USED TO EXECUTE PROGRAM

PBLOCK	LABEL	NEAR
PBENV	DW	0			;ENVIRONMENT SEGMENT
PBCMD	DW	80H,0			;COMMAND LINE ADDRESS
PBFCB1	DW	5CH,0			;FCB1 ADDRESS
PBFCB2	DW	6CH,0			;FCB2 ADDRESS

FNDBUF	DB	43 DUP (0)		;FIND BUFFER

BADVER	DB	13,10,7,'This program requires MS-DOS version 2 or '
	DB	'above.',13,10,'$'
NOFIND	DB	13,10,"Can't find $"
NOEXEC	DB	13,10,"Can't execute "
PRGNAM	DB	80 DUP (0)		;NAME OF PROGRAM TO RUN
	DB	13,10,'$'

SIGNON	DB	13,10,'RUNPROG Version 1.0.',13,10
	DB	"Copyright (C) Heath/Zenith Users' Group 1987.  "
	DB	'All Rights Reserved.',13,10,'$'
NPMSG	DB	13,10,'This program runs another program as a child,',13,10
	DB	'with the top 64k of system memory reserved.',13,10,10
	DB	'To use this program, enter',13,10,10
	DB	'  RUNPROG <program> [<arguments>]',13,10,10
	DB	'Where <program> is the program you want to',13,10
	DB	'run, and <arguments> are any command line arg-',13,10
	DB	'uments required by the program.',13,10,'$'

ENDADR	EQU	$+256			;END OF THIS PROGRAM

CODE	ENDS
	END	START
